/*
 -------------------------------------------------------------------------------
 | Producer - Copyright (C) 2001-2007  Don Burns                               |
 |                                                                             |
 | This library is free software; you can redistribute it and/or modify        |
 | it under the terms of the GNU Lesser General Public License as published    |
 | by the Free Software Foundation; either version 3 of the License, or        |
 | (at your option) any later version.                                         |
 |                                                                             |
 | This library is distributed in the hope that it will be useful, but         |
 | WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  |
 | or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public     |
 | License for more details.                                                   |
 |                                                                             |
 | You should have received a copy of the GNU Lesser General Public License    |
 | along with this software; if not, write to the Free Software Foundation,    |
 | Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.               |
 |                                                                             |
 -------------------------------------------------------------------------------
 */

#ifndef GLUT_RENDER_SURFACE_DEF
#define GLUT_RENDER_SURFACE_DEF

#include "glut.h"
#include <Producer/RenderSurface.h>

class GLUTRenderSurface: public Producer::RenderSurface
{
    public:
        GLUTRenderSurface(
                int x, int y, unsigned int width, unsigned int height, 
                unsigned int mode = (GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH | GLUT_ALPHA))
        {
            glutInitDisplayMode( mode );
            glutInitWindowPosition( x, y );
            glutInitWindowSize( width, height );
            glutCreateWindow( "GLUTProducer Render Surface" );
            glutReshapeFunc( s_reshape );
        }

        virtual bool realize( Producer::VisualChooser *vc=NULL, Producer::GLContext sharedGLContext=0 )
        {
            GLUTRenderSurface::currentRenderSurface = this;
            return _realized = true;
        }
        
        virtual bool makeCurrent(bool=true )
        {
            return true;
        }

        virtual void swapBuffers(void)
        {
            glutSwapBuffers();
        }

        static GLUTRenderSurface *currentRenderSurface;

        static void s_reshape( int width, int height )
        {
            currentRenderSurface->setWindowRectangle( 0, 0, width, height, false );
        }
};

GLUTRenderSurface *GLUTRenderSurface::currentRenderSurface = 0L;
#endif
